
local function LoadModel(model)
	while not HasModelLoaded(model) do
		RequestModel(model)
		Wait(10)
	end
end

local function LoadAnim(dict)
	while not HasAnimDictLoaded(dict) do
		RequestAnimDict(dict)
		Wait(10)
	end
end

local function DrawText3Ds(coords, text, scale, color, notRect)
	local x,y,z = coords.x, coords.y, coords.z
	local onScreen, _x, _y = World3dToScreen2d(x, y, z)
	local pX, pY, pZ = table.unpack(GetGameplayCamCoords())

  color = color

  if not color then
    color = {255, 255, 255, 215}
  end

	SetTextScale(scale, scale)
	SetTextFont(4)
	SetTextProportional(1)
	SetTextEntry("STRING")
	SetTextCentre(1)
	SetTextColour(color[1], color[2], color[3], color[4])

	AddTextComponentString(text)
	DrawText(_x, _y)

  if not notRect then
    local factor = (string.len(text)) / 370

    DrawRect(_x, _y + 0.0150, 0.005 + factor, 0.025, 41, 11, 41, 100)
  end
end

local function GoToBed(wheelchairObject)
	local ped = PlayerPedId()
	LoadAnim("anim@gangops@morgue@table@")
	AttachEntityToEntity(ped, wheelchairObject, 0, -0.00, 0.1, 1.05, 0.0, 0.0, 179.0, 0.0, false, false, false, false, 2, true)
	while IsEntityAttachedToEntity(ped, wheelchairObject) do
		Wait(5)
		if not IsEntityPlayingAnim(ped, 'anim@gangops@morgue@table@', 'ko_front', 3) then
			TaskPlayAnim(ped, 'anim@gangops@morgue@table@', 'ko_front', 8.0, 8.0, -1, 69, 1, false, false, false)
		end
		if IsControlJustPressed(0, 73) then
			DetachEntity(wheelchairObject, true, true)
			ClearPedTasks(ped)
		end
	end
end

local function Pickup(wheelchairObject)
	local ped = PlayerPedId()
	NetworkRequestControlOfEntity(wheelchairObject)
	LoadAnim("anim@heists@box_carry@")
	AttachEntityToEntity(wheelchairObject, ped, ped, -0.05, 1.3, -0.05 , 180.0, 180.0, 180.0, 0.0, false, false, true, false, 2, true)
	while IsEntityAttachedToEntity(wheelchairObject, ped) do
		Wait(5)
		if not IsEntityPlayingAnim(ped, 'anim@heists@box_carry@', 'idle', 3) then
			TaskPlayAnim(ped, 'anim@heists@box_carry@', 'idle', 8.0, 8.0, -1, 50, 0, false, false, false)
		end
		if IsControlJustPressed(0, 73) then
			DetachEntity(wheelchairObject, true, true)
			ClearPedTasks(ped)
		end
	end
end

local beds = {
	'prop_ld_binbag_01'
}

local nearObject

Citizen.CreateThread(function()
	while true do
		Wait(500)
		local pedCoords = GetEntityCoords(PlayerPedId())
		for k,v in pairs(beds) do
			local closestObject = GetClosestObjectOfType(pedCoords, 3.0, GetHashKey(v), false)
			if DoesEntityExist(closestObject) then
				nearObject = closestObject
				break
			else
				nearObject = nil
			end
		end
	end
end)

Citizen.CreateThread(function()
	while true do
		local biSleep = 500
    if nearObject then
		biSleep = 3
      
			local wheelChairCoords = GetEntityCoords(nearObject)
			local text = '[~b~E~s~] Pentru a lua patul pe sus \n [~b~G~s~] Pentru a te pune jos \n [~b~X~w~] Pentru a te ridica'

      DrawText3Ds(wheelChairCoords, text, 0.3, nil, true)

      if IsControlJustPressed(0, 38) then
        Pickup(nearObject)
      elseif IsControlJustPressed(0, 47) then
        GoToBed(nearObject)
      end

    end
	Citizen.Wait(biSleep)
	end
end)

RegisterNetEvent('targa:stretcher:spawn')
AddEventHandler('targa:stretcher:spawn', function()
	LoadModel('prop_ld_binbag_01')
	local wheelchair = CreateObject(GetHashKey('prop_ld_binbag_01'), GetEntityCoords(PlayerPedId())-1, true, true, true)
end)

RegisterNetEvent('targa:stretcher:delete')
AddEventHandler('targa:stretcher:delete', function()
	local wheelchair = GetClosestObjectOfType(GetEntityCoords(PlayerPedId()), 10.0, GetHashKey('prop_ld_binbag_01'))
	if DoesEntityExist(wheelchair) then
		DeleteEntity(wheelchair)
	end
end)